#pragma once

#include "AbstractVisualNode.h"

#include "Pointer.h"

class BlochSphere;
class CircleNode;
class LineNode;

class BlochSphereNode : public AbstractVisualNode
{
public:
    BlochSphereNode(const Point2& location);

    void setContent(BlochSphere* content);

    void update(SceneInfo* sceneInfo) override;

    void setSize(double size);
private:
    double mSize{ 1.0 };
    bool mContentDirty{ true };
    BlochSphere* mContent{ nullptr };

    Ptr<CircleNode> mOuterCircle;
    Ptr<CircleNode> mInnerCircle;
    Ptr<CircleNode> mCentreCircle;
    Ptr<CircleNode> mStateMarkerCircle;
    Ptr<LineNode> mXAxis;
    Ptr<LineNode> mYAxis;
    Ptr<LineNode> mZAxis;
    Ptr<LineNode> mStateVector;
};
