#pragma once

#include "AbstractVisualNode.h"

#include Map.h

class QuantumCircuit;
class QuantumCircuitElement;
class AbstractQuantumWire;

class QuantumTerminalNode;
class QuantumGateNode;
class QuantumWireNode;
class QuantumCircuitElementNode;

class QuantumCircuitNode : public AbstractVisualNode
{
public:
	QuantumCircuitNode(const Transform& t = {});

	void setContent(QuantumCircuit* circuit);

	void update(SceneInfo* sceneInfo);
private:
	void createOrUpdateGeometry(SceneInfo* sceneInfo);

	void buildWireConnections();

	bool mContentDirty{ true };
	QuantumCircuit* mContent{ nullptr };

	Vector<Ptr<QuantumTerminalNode> > mInputTerminalNodes;
	Vector<Ptr<QuantumTerminalNode> > mOutputTerminalNodes;
	Vector<Ptr<QuantumGateNode> > mGateNodes;
	Vector<Ptr<QuantumWireNode> > mWireNodes;

	Map<AbstractQuantumWire*, QuantumCircuitElement*> mWireInputConnections;
	Map<AbstractQuantumWire*, QuantumCircuitElement*> mWireOutputConnections;

	Map<QuantumCircuitElement*, QuantumCircuitElementNode*> mNodesForContent;
};