#pragma once

#include "QuantumCircuitElementNode.h"

class RectangleNode;
class EquationNode;
class QuantumGate;
class LatexMathExpression;

class QuantumGateNode : public QuantumCircuitElementNode
{
public:
	QuantumGateNode(const Transform& t = {});

	virtual ~QuantumGateNode();

	Point2 getConnectionLocation(AbstractQuantumWire* wire) const override;

	void setContent(QuantumGate* gate);

	void update(SceneInfo* sceneInfo);
private:
	void createOrUpdateGeometry(SceneInfo* sceneInfo);

	QuantumGate* mContent{ nullptr };
	bool mContentDirty{ true };

	Ptr<RectangleNode> mBody;

	double mBodyWidth = 30;
	double mBodyHeight = 24;
	Ptr<LatexMathExpression> mLabelExpression;
	Ptr<EquationNode> mLabel;
};